#include "parser/parser.cpp"

// This is the part of NACRE project.
// NACRE -- Numerical Analysis / Computer REsearch.
//-------------------------------------------------------------------

// Copyleft (c) 2006 Alexey Beshenov <bav.272304@gmail.com>.

// NACRE is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation.

// NACRE is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details (the COPYING file).

//-----------------------------------------------------------------------------

#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

TParser parser;

long double f (long double x)
    {
    long double val;
    try { val = parser.Evaluate(x); }
    catch(TError error) { puts(error.error); exit(EXIT_FAILURE); }
    return val;
    }


//-------------------------------------------------------------------

string builtin_list()
    {
    ostringstream builtin;
    builtin << endl << "Functions:" << endl;
    builtin << "   ^ -- power" << endl;
    builtin << "   " << DESIGNATION_SIN << "(x) -- sine" << endl;
    builtin << "   " << DESIGNATION_COS << "(x) -- cosine" << endl;
    builtin << "   " << DESIGNATION_TG << "(x) -- tangent" << endl;
    builtin << "   " << DESIGNATION_CTG << "(x) -- cotangent" << endl;
    builtin << "   " << DESIGNATION_ARCSIN << "(x) -- arc-sine" << endl;
    builtin << "   " << DESIGNATION_ARCCOS << "(x) -- arc-cosine" << endl;
    builtin << "   " << DESIGNATION_ARCTG << "(x) -- arc-tangent" << endl;
    builtin << "   " << DESIGNATION_ARCCTG << "(x) -- arc-cotangent" << endl;
    builtin << "   " << DESIGNATION_SH << "(x) -- hyperbolic sine" << endl;
    builtin << "   " << DESIGNATION_CH << "(x) -- hyperbolic cosine" << endl;
    builtin << "   " << DESIGNATION_TH << "(x) -- hyperbolic tangent" << endl;
    builtin << "   " << DESIGNATION_CTH << "(x) -- hyperbolic cotangent" << endl;
    builtin << "   " << DESIGNATION_EXP << "(x) -- e^x" << endl;
    builtin << "   " << DESIGNATION_LG << "(x) -- decimal logarithm" << endl;
    builtin << "   " << DESIGNATION_LN << "(x) -- natural logarithm" << endl;
    builtin << "   " << DESIGNATION_SQRT << "(x) -- square root" << endl;
    builtin << endl;
    builtin << "   QUOTE THE EXPRESSION!" << endl;

    return builtin.str();
    }


string builtin_functions = builtin_list();
